-------------------------------------------------------------------------------
-- Simple LED Flasher
-------------------------------------------------------------------------------

library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

--============================================================================--
--================================== ENTITY ==================================--
--============================================================================--
entity led_flash is
	port (
		Res_N       : in  Std_Logic;                         
		Clk  			: in  Std_Logic;             
		Control		: in 	std_Logic;
		LED_drive   : out Std_Logic_Vector(3 downto 0)
	);
end led_flash;

--============================================================================--
--================================ ARCHITECTURE ==============================--
--============================================================================--
architecture RTL of led_flash is

  signal Simple_Counter  : Unsigned(26 downto 0);
  signal LED_internal	 : std_Logic_Vector(3 downto 0);
  signal Count_internal	 : std_Logic_Vector(26 downto 0);
  
begin

	-------------------------
	-- Simple counter process
	-------------------------
	Mr_counter: process (Res_N, Clk)
	begin
		if Res_N = '0' then
			Simple_Counter <= (others => '0');
		elsif Rising_edge(Clk) then
			Simple_Counter <= Simple_Counter + 1;
		end if;
	end process Mr_counter;    

	Count_internal <= not(std_Logic_Vector(Simple_Counter));
	
	LED_drive <= Count_internal (26 downto 23);
  
end RTL;










