-- power1.vhd

-- Generated using ACDS version 15.1 185

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity power1 is
	port (
		altpll_0_c1_clk          : out std_logic;                                        --     altpll_0_c1.clk
		clk_clk                  : in  std_logic                     := '0';             --             clk.clk
		reset_reset_n            : in  std_logic                     := '0';             --           reset.reset_n
		test_pio_output_in_port  : in  std_logic_vector(15 downto 0) := (others => '0'); -- test_pio_output.in_port
		test_pio_output_out_port : out std_logic_vector(15 downto 0)                     --                .out_port
	);
end entity power1;

architecture rtl of power1 is
	component power1_ADC is
		port (
			clock_clk                  : in  std_logic                     := 'X';             -- clk
			reset_sink_reset_n         : in  std_logic                     := 'X';             -- reset_n
			adc_pll_clock_clk          : in  std_logic                     := 'X';             -- clk
			adc_pll_locked_export      : in  std_logic                     := 'X';             -- export
			sequencer_csr_address      : in  std_logic                     := 'X';             -- address
			sequencer_csr_read         : in  std_logic                     := 'X';             -- read
			sequencer_csr_write        : in  std_logic                     := 'X';             -- write
			sequencer_csr_writedata    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			sequencer_csr_readdata     : out std_logic_vector(31 downto 0);                    -- readdata
			sample_store_csr_address   : in  std_logic_vector(6 downto 0)  := (others => 'X'); -- address
			sample_store_csr_read      : in  std_logic                     := 'X';             -- read
			sample_store_csr_write     : in  std_logic                     := 'X';             -- write
			sample_store_csr_writedata : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			sample_store_csr_readdata  : out std_logic_vector(31 downto 0);                    -- readdata
			sample_store_irq_irq       : out std_logic                                         -- irq
		);
	end component power1_ADC;

	component power1_JTAG_UART is
		port (
			clk            : in  std_logic                     := 'X';             -- clk
			rst_n          : in  std_logic                     := 'X';             -- reset_n
			av_chipselect  : in  std_logic                     := 'X';             -- chipselect
			av_address     : in  std_logic                     := 'X';             -- address
			av_read_n      : in  std_logic                     := 'X';             -- read_n
			av_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			av_write_n     : in  std_logic                     := 'X';             -- write_n
			av_writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			av_waitrequest : out std_logic;                                        -- waitrequest
			av_irq         : out std_logic                                         -- irq
		);
	end component power1_JTAG_UART;

	component power1_NIOS is
		port (
			clk                                 : in  std_logic                     := 'X';             -- clk
			reset_n                             : in  std_logic                     := 'X';             -- reset_n
			reset_req                           : in  std_logic                     := 'X';             -- reset_req
			d_address                           : out std_logic_vector(16 downto 0);                    -- address
			d_byteenable                        : out std_logic_vector(3 downto 0);                     -- byteenable
			d_read                              : out std_logic;                                        -- read
			d_readdata                          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			d_waitrequest                       : in  std_logic                     := 'X';             -- waitrequest
			d_write                             : out std_logic;                                        -- write
			d_writedata                         : out std_logic_vector(31 downto 0);                    -- writedata
			debug_mem_slave_debugaccess_to_roms : out std_logic;                                        -- debugaccess
			i_address                           : out std_logic_vector(16 downto 0);                    -- address
			i_read                              : out std_logic;                                        -- read
			i_readdata                          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			i_waitrequest                       : in  std_logic                     := 'X';             -- waitrequest
			irq                                 : in  std_logic_vector(31 downto 0) := (others => 'X'); -- irq
			debug_reset_request                 : out std_logic;                                        -- reset
			debug_mem_slave_address             : in  std_logic_vector(8 downto 0)  := (others => 'X'); -- address
			debug_mem_slave_byteenable          : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			debug_mem_slave_debugaccess         : in  std_logic                     := 'X';             -- debugaccess
			debug_mem_slave_read                : in  std_logic                     := 'X';             -- read
			debug_mem_slave_readdata            : out std_logic_vector(31 downto 0);                    -- readdata
			debug_mem_slave_waitrequest         : out std_logic;                                        -- waitrequest
			debug_mem_slave_write               : in  std_logic                     := 'X';             -- write
			debug_mem_slave_writedata           : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			dummy_ci_port                       : out std_logic                                         -- readra
		);
	end component power1_NIOS;

	component power1_NIOS_IO is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- address
			write_n    : in  std_logic                     := 'X';             -- write_n
			writedata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			chipselect : in  std_logic                     := 'X';             -- chipselect
			readdata   : out std_logic_vector(31 downto 0);                    -- readdata
			in_port    : in  std_logic_vector(15 downto 0) := (others => 'X'); -- export
			out_port   : out std_logic_vector(15 downto 0)                     -- export
		);
	end component power1_NIOS_IO;

	component power1_NIOS_RAM is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			address    : in  std_logic_vector(11 downto 0) := (others => 'X'); -- address
			clken      : in  std_logic                     := 'X';             -- clken
			chipselect : in  std_logic                     := 'X';             -- chipselect
			write      : in  std_logic                     := 'X';             -- write
			readdata   : out std_logic_vector(31 downto 0);                    -- readdata
			writedata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			byteenable : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			reset      : in  std_logic                     := 'X';             -- reset
			reset_req  : in  std_logic                     := 'X'              -- reset_req
		);
	end component power1_NIOS_RAM;

	component power1_Timer is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			writedata  : in  std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			readdata   : out std_logic_vector(15 downto 0);                    -- readdata
			chipselect : in  std_logic                     := 'X';             -- chipselect
			write_n    : in  std_logic                     := 'X';             -- write_n
			irq        : out std_logic                                         -- irq
		);
	end component power1_Timer;

	component power1_altpll_0 is
		port (
			clk       : in  std_logic                     := 'X';             -- clk
			reset     : in  std_logic                     := 'X';             -- reset
			read      : in  std_logic                     := 'X';             -- read
			write     : in  std_logic                     := 'X';             -- write
			address   : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- address
			readdata  : out std_logic_vector(31 downto 0);                    -- readdata
			writedata : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			c0        : out std_logic;                                        -- clk
			c1        : out std_logic;                                        -- clk
			areset    : in  std_logic                     := 'X';             -- export
			locked    : out std_logic;                                        -- export
			phasedone : out std_logic                                         -- export
		);
	end component power1_altpll_0;

	component reset_sync is
		port (
			Clk                    : in  std_logic := 'X'; -- clk
			Res_N                  : in  std_logic := 'X'; -- reset
			PLL_Locked             : in  std_logic := 'X'; -- export
			Res_N_Out              : out std_logic;        -- reset
			PLL_Locked_Passthrough : out std_logic         -- export
		);
	end component reset_sync;

	component power1_mm_interconnect_0 is
		port (
			altpll_0_c0_clk                         : in  std_logic                     := 'X';             -- clk
			NIOS_reset_reset_bridge_in_reset_reset  : in  std_logic                     := 'X';             -- reset
			NIOS_data_master_address                : in  std_logic_vector(16 downto 0) := (others => 'X'); -- address
			NIOS_data_master_waitrequest            : out std_logic;                                        -- waitrequest
			NIOS_data_master_byteenable             : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			NIOS_data_master_read                   : in  std_logic                     := 'X';             -- read
			NIOS_data_master_readdata               : out std_logic_vector(31 downto 0);                    -- readdata
			NIOS_data_master_write                  : in  std_logic                     := 'X';             -- write
			NIOS_data_master_writedata              : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			NIOS_data_master_debugaccess            : in  std_logic                     := 'X';             -- debugaccess
			NIOS_instruction_master_address         : in  std_logic_vector(16 downto 0) := (others => 'X'); -- address
			NIOS_instruction_master_waitrequest     : out std_logic;                                        -- waitrequest
			NIOS_instruction_master_read            : in  std_logic                     := 'X';             -- read
			NIOS_instruction_master_readdata        : out std_logic_vector(31 downto 0);                    -- readdata
			ADC_sample_store_csr_address            : out std_logic_vector(6 downto 0);                     -- address
			ADC_sample_store_csr_write              : out std_logic;                                        -- write
			ADC_sample_store_csr_read               : out std_logic;                                        -- read
			ADC_sample_store_csr_readdata           : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			ADC_sample_store_csr_writedata          : out std_logic_vector(31 downto 0);                    -- writedata
			ADC_sequencer_csr_address               : out std_logic_vector(0 downto 0);                     -- address
			ADC_sequencer_csr_write                 : out std_logic;                                        -- write
			ADC_sequencer_csr_read                  : out std_logic;                                        -- read
			ADC_sequencer_csr_readdata              : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			ADC_sequencer_csr_writedata             : out std_logic_vector(31 downto 0);                    -- writedata
			JTAG_UART_avalon_jtag_slave_address     : out std_logic_vector(0 downto 0);                     -- address
			JTAG_UART_avalon_jtag_slave_write       : out std_logic;                                        -- write
			JTAG_UART_avalon_jtag_slave_read        : out std_logic;                                        -- read
			JTAG_UART_avalon_jtag_slave_readdata    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			JTAG_UART_avalon_jtag_slave_writedata   : out std_logic_vector(31 downto 0);                    -- writedata
			JTAG_UART_avalon_jtag_slave_waitrequest : in  std_logic                     := 'X';             -- waitrequest
			JTAG_UART_avalon_jtag_slave_chipselect  : out std_logic;                                        -- chipselect
			NIOS_debug_mem_slave_address            : out std_logic_vector(8 downto 0);                     -- address
			NIOS_debug_mem_slave_write              : out std_logic;                                        -- write
			NIOS_debug_mem_slave_read               : out std_logic;                                        -- read
			NIOS_debug_mem_slave_readdata           : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			NIOS_debug_mem_slave_writedata          : out std_logic_vector(31 downto 0);                    -- writedata
			NIOS_debug_mem_slave_byteenable         : out std_logic_vector(3 downto 0);                     -- byteenable
			NIOS_debug_mem_slave_waitrequest        : in  std_logic                     := 'X';             -- waitrequest
			NIOS_debug_mem_slave_debugaccess        : out std_logic;                                        -- debugaccess
			NIOS_IO_s1_address                      : out std_logic_vector(1 downto 0);                     -- address
			NIOS_IO_s1_write                        : out std_logic;                                        -- write
			NIOS_IO_s1_readdata                     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			NIOS_IO_s1_writedata                    : out std_logic_vector(31 downto 0);                    -- writedata
			NIOS_IO_s1_chipselect                   : out std_logic;                                        -- chipselect
			NIOS_RAM_s1_address                     : out std_logic_vector(11 downto 0);                    -- address
			NIOS_RAM_s1_write                       : out std_logic;                                        -- write
			NIOS_RAM_s1_readdata                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			NIOS_RAM_s1_writedata                   : out std_logic_vector(31 downto 0);                    -- writedata
			NIOS_RAM_s1_byteenable                  : out std_logic_vector(3 downto 0);                     -- byteenable
			NIOS_RAM_s1_chipselect                  : out std_logic;                                        -- chipselect
			NIOS_RAM_s1_clken                       : out std_logic;                                        -- clken
			Timer_s1_address                        : out std_logic_vector(2 downto 0);                     -- address
			Timer_s1_write                          : out std_logic;                                        -- write
			Timer_s1_readdata                       : in  std_logic_vector(15 downto 0) := (others => 'X'); -- readdata
			Timer_s1_writedata                      : out std_logic_vector(15 downto 0);                    -- writedata
			Timer_s1_chipselect                     : out std_logic                                         -- chipselect
		);
	end component power1_mm_interconnect_0;

	component power1_irq_mapper is
		port (
			clk           : in  std_logic                     := 'X'; -- clk
			reset         : in  std_logic                     := 'X'; -- reset
			receiver0_irq : in  std_logic                     := 'X'; -- irq
			receiver1_irq : in  std_logic                     := 'X'; -- irq
			sender_irq    : out std_logic_vector(31 downto 0)         -- irq
		);
	end component power1_irq_mapper;

	component power1_rst_controller is
		generic (
			NUM_RESET_INPUTS          : integer := 6;
			OUTPUT_RESET_SYNC_EDGES   : string  := "deassert";
			SYNC_DEPTH                : integer := 2;
			RESET_REQUEST_PRESENT     : integer := 0;
			RESET_REQ_WAIT_TIME       : integer := 1;
			MIN_RST_ASSERTION_TIME    : integer := 3;
			RESET_REQ_EARLY_DSRT_TIME : integer := 1;
			USE_RESET_REQUEST_IN0     : integer := 0;
			USE_RESET_REQUEST_IN1     : integer := 0;
			USE_RESET_REQUEST_IN2     : integer := 0;
			USE_RESET_REQUEST_IN3     : integer := 0;
			USE_RESET_REQUEST_IN4     : integer := 0;
			USE_RESET_REQUEST_IN5     : integer := 0;
			USE_RESET_REQUEST_IN6     : integer := 0;
			USE_RESET_REQUEST_IN7     : integer := 0;
			USE_RESET_REQUEST_IN8     : integer := 0;
			USE_RESET_REQUEST_IN9     : integer := 0;
			USE_RESET_REQUEST_IN10    : integer := 0;
			USE_RESET_REQUEST_IN11    : integer := 0;
			USE_RESET_REQUEST_IN12    : integer := 0;
			USE_RESET_REQUEST_IN13    : integer := 0;
			USE_RESET_REQUEST_IN14    : integer := 0;
			USE_RESET_REQUEST_IN15    : integer := 0;
			ADAPT_RESET_REQUEST       : integer := 0
		);
		port (
			reset_in0      : in  std_logic := 'X'; -- reset
			clk            : in  std_logic := 'X'; -- clk
			reset_out      : out std_logic;        -- reset
			reset_req      : out std_logic;        -- reset_req
			reset_req_in0  : in  std_logic := 'X'; -- reset_req
			reset_in1      : in  std_logic := 'X'; -- reset
			reset_req_in1  : in  std_logic := 'X'; -- reset_req
			reset_in2      : in  std_logic := 'X'; -- reset
			reset_req_in2  : in  std_logic := 'X'; -- reset_req
			reset_in3      : in  std_logic := 'X'; -- reset
			reset_req_in3  : in  std_logic := 'X'; -- reset_req
			reset_in4      : in  std_logic := 'X'; -- reset
			reset_req_in4  : in  std_logic := 'X'; -- reset_req
			reset_in5      : in  std_logic := 'X'; -- reset
			reset_req_in5  : in  std_logic := 'X'; -- reset_req
			reset_in6      : in  std_logic := 'X'; -- reset
			reset_req_in6  : in  std_logic := 'X'; -- reset_req
			reset_in7      : in  std_logic := 'X'; -- reset
			reset_req_in7  : in  std_logic := 'X'; -- reset_req
			reset_in8      : in  std_logic := 'X'; -- reset
			reset_req_in8  : in  std_logic := 'X'; -- reset_req
			reset_in9      : in  std_logic := 'X'; -- reset
			reset_req_in9  : in  std_logic := 'X'; -- reset_req
			reset_in10     : in  std_logic := 'X'; -- reset
			reset_req_in10 : in  std_logic := 'X'; -- reset_req
			reset_in11     : in  std_logic := 'X'; -- reset
			reset_req_in11 : in  std_logic := 'X'; -- reset_req
			reset_in12     : in  std_logic := 'X'; -- reset
			reset_req_in12 : in  std_logic := 'X'; -- reset_req
			reset_in13     : in  std_logic := 'X'; -- reset
			reset_req_in13 : in  std_logic := 'X'; -- reset_req
			reset_in14     : in  std_logic := 'X'; -- reset
			reset_req_in14 : in  std_logic := 'X'; -- reset_req
			reset_in15     : in  std_logic := 'X'; -- reset
			reset_req_in15 : in  std_logic := 'X'  -- reset_req
		);
	end component power1_rst_controller;

	component power1_rst_controller_001 is
		generic (
			NUM_RESET_INPUTS          : integer := 6;
			OUTPUT_RESET_SYNC_EDGES   : string  := "deassert";
			SYNC_DEPTH                : integer := 2;
			RESET_REQUEST_PRESENT     : integer := 0;
			RESET_REQ_WAIT_TIME       : integer := 1;
			MIN_RST_ASSERTION_TIME    : integer := 3;
			RESET_REQ_EARLY_DSRT_TIME : integer := 1;
			USE_RESET_REQUEST_IN0     : integer := 0;
			USE_RESET_REQUEST_IN1     : integer := 0;
			USE_RESET_REQUEST_IN2     : integer := 0;
			USE_RESET_REQUEST_IN3     : integer := 0;
			USE_RESET_REQUEST_IN4     : integer := 0;
			USE_RESET_REQUEST_IN5     : integer := 0;
			USE_RESET_REQUEST_IN6     : integer := 0;
			USE_RESET_REQUEST_IN7     : integer := 0;
			USE_RESET_REQUEST_IN8     : integer := 0;
			USE_RESET_REQUEST_IN9     : integer := 0;
			USE_RESET_REQUEST_IN10    : integer := 0;
			USE_RESET_REQUEST_IN11    : integer := 0;
			USE_RESET_REQUEST_IN12    : integer := 0;
			USE_RESET_REQUEST_IN13    : integer := 0;
			USE_RESET_REQUEST_IN14    : integer := 0;
			USE_RESET_REQUEST_IN15    : integer := 0;
			ADAPT_RESET_REQUEST       : integer := 0
		);
		port (
			reset_in0      : in  std_logic := 'X'; -- reset
			clk            : in  std_logic := 'X'; -- clk
			reset_out      : out std_logic;        -- reset
			reset_req      : out std_logic;        -- reset_req
			reset_req_in0  : in  std_logic := 'X'; -- reset_req
			reset_in1      : in  std_logic := 'X'; -- reset
			reset_req_in1  : in  std_logic := 'X'; -- reset_req
			reset_in2      : in  std_logic := 'X'; -- reset
			reset_req_in2  : in  std_logic := 'X'; -- reset_req
			reset_in3      : in  std_logic := 'X'; -- reset
			reset_req_in3  : in  std_logic := 'X'; -- reset_req
			reset_in4      : in  std_logic := 'X'; -- reset
			reset_req_in4  : in  std_logic := 'X'; -- reset_req
			reset_in5      : in  std_logic := 'X'; -- reset
			reset_req_in5  : in  std_logic := 'X'; -- reset_req
			reset_in6      : in  std_logic := 'X'; -- reset
			reset_req_in6  : in  std_logic := 'X'; -- reset_req
			reset_in7      : in  std_logic := 'X'; -- reset
			reset_req_in7  : in  std_logic := 'X'; -- reset_req
			reset_in8      : in  std_logic := 'X'; -- reset
			reset_req_in8  : in  std_logic := 'X'; -- reset_req
			reset_in9      : in  std_logic := 'X'; -- reset
			reset_req_in9  : in  std_logic := 'X'; -- reset_req
			reset_in10     : in  std_logic := 'X'; -- reset
			reset_req_in10 : in  std_logic := 'X'; -- reset_req
			reset_in11     : in  std_logic := 'X'; -- reset
			reset_req_in11 : in  std_logic := 'X'; -- reset_req
			reset_in12     : in  std_logic := 'X'; -- reset
			reset_req_in12 : in  std_logic := 'X'; -- reset_req
			reset_in13     : in  std_logic := 'X'; -- reset
			reset_req_in13 : in  std_logic := 'X'; -- reset_req
			reset_in14     : in  std_logic := 'X'; -- reset
			reset_req_in14 : in  std_logic := 'X'; -- reset_req
			reset_in15     : in  std_logic := 'X'; -- reset
			reset_req_in15 : in  std_logic := 'X'  -- reset_req
		);
	end component power1_rst_controller_001;

	signal altpll_0_c0_clk                                               : std_logic;                     -- altpll_0:c0 -> [ADC:adc_pll_clock_clk, ADC:clock_clk, JTAG_UART:clk, NIOS:clk, NIOS_IO:clk, NIOS_RAM:clk, Timer:clk, custom_reset_sync_0:Clk, irq_mapper:clk, mm_interconnect_0:altpll_0_c0_clk, rst_controller:clk, rst_controller_002:clk]
	signal altpll_0_locked_conduit_export                                : std_logic;                     -- altpll_0:locked -> custom_reset_sync_0:PLL_Locked
	signal custom_reset_sync_0_pll_locked_passthrough_export             : std_logic;                     -- custom_reset_sync_0:PLL_Locked_Passthrough -> ADC:adc_pll_locked_export
	signal nios_data_master_readdata                                     : std_logic_vector(31 downto 0); -- mm_interconnect_0:NIOS_data_master_readdata -> NIOS:d_readdata
	signal nios_data_master_waitrequest                                  : std_logic;                     -- mm_interconnect_0:NIOS_data_master_waitrequest -> NIOS:d_waitrequest
	signal nios_data_master_debugaccess                                  : std_logic;                     -- NIOS:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:NIOS_data_master_debugaccess
	signal nios_data_master_address                                      : std_logic_vector(16 downto 0); -- NIOS:d_address -> mm_interconnect_0:NIOS_data_master_address
	signal nios_data_master_byteenable                                   : std_logic_vector(3 downto 0);  -- NIOS:d_byteenable -> mm_interconnect_0:NIOS_data_master_byteenable
	signal nios_data_master_read                                         : std_logic;                     -- NIOS:d_read -> mm_interconnect_0:NIOS_data_master_read
	signal nios_data_master_write                                        : std_logic;                     -- NIOS:d_write -> mm_interconnect_0:NIOS_data_master_write
	signal nios_data_master_writedata                                    : std_logic_vector(31 downto 0); -- NIOS:d_writedata -> mm_interconnect_0:NIOS_data_master_writedata
	signal nios_instruction_master_readdata                              : std_logic_vector(31 downto 0); -- mm_interconnect_0:NIOS_instruction_master_readdata -> NIOS:i_readdata
	signal nios_instruction_master_waitrequest                           : std_logic;                     -- mm_interconnect_0:NIOS_instruction_master_waitrequest -> NIOS:i_waitrequest
	signal nios_instruction_master_address                               : std_logic_vector(16 downto 0); -- NIOS:i_address -> mm_interconnect_0:NIOS_instruction_master_address
	signal nios_instruction_master_read                                  : std_logic;                     -- NIOS:i_read -> mm_interconnect_0:NIOS_instruction_master_read
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect      : std_logic;                     -- mm_interconnect_0:JTAG_UART_avalon_jtag_slave_chipselect -> JTAG_UART:av_chipselect
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata        : std_logic_vector(31 downto 0); -- JTAG_UART:av_readdata -> mm_interconnect_0:JTAG_UART_avalon_jtag_slave_readdata
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest     : std_logic;                     -- JTAG_UART:av_waitrequest -> mm_interconnect_0:JTAG_UART_avalon_jtag_slave_waitrequest
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_address         : std_logic_vector(0 downto 0);  -- mm_interconnect_0:JTAG_UART_avalon_jtag_slave_address -> JTAG_UART:av_address
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_read            : std_logic;                     -- mm_interconnect_0:JTAG_UART_avalon_jtag_slave_read -> mm_interconnect_0_jtag_uart_avalon_jtag_slave_read:in
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_write           : std_logic;                     -- mm_interconnect_0:JTAG_UART_avalon_jtag_slave_write -> mm_interconnect_0_jtag_uart_avalon_jtag_slave_write:in
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata       : std_logic_vector(31 downto 0); -- mm_interconnect_0:JTAG_UART_avalon_jtag_slave_writedata -> JTAG_UART:av_writedata
	signal mm_interconnect_0_nios_debug_mem_slave_readdata               : std_logic_vector(31 downto 0); -- NIOS:debug_mem_slave_readdata -> mm_interconnect_0:NIOS_debug_mem_slave_readdata
	signal mm_interconnect_0_nios_debug_mem_slave_waitrequest            : std_logic;                     -- NIOS:debug_mem_slave_waitrequest -> mm_interconnect_0:NIOS_debug_mem_slave_waitrequest
	signal mm_interconnect_0_nios_debug_mem_slave_debugaccess            : std_logic;                     -- mm_interconnect_0:NIOS_debug_mem_slave_debugaccess -> NIOS:debug_mem_slave_debugaccess
	signal mm_interconnect_0_nios_debug_mem_slave_address                : std_logic_vector(8 downto 0);  -- mm_interconnect_0:NIOS_debug_mem_slave_address -> NIOS:debug_mem_slave_address
	signal mm_interconnect_0_nios_debug_mem_slave_read                   : std_logic;                     -- mm_interconnect_0:NIOS_debug_mem_slave_read -> NIOS:debug_mem_slave_read
	signal mm_interconnect_0_nios_debug_mem_slave_byteenable             : std_logic_vector(3 downto 0);  -- mm_interconnect_0:NIOS_debug_mem_slave_byteenable -> NIOS:debug_mem_slave_byteenable
	signal mm_interconnect_0_nios_debug_mem_slave_write                  : std_logic;                     -- mm_interconnect_0:NIOS_debug_mem_slave_write -> NIOS:debug_mem_slave_write
	signal mm_interconnect_0_nios_debug_mem_slave_writedata              : std_logic_vector(31 downto 0); -- mm_interconnect_0:NIOS_debug_mem_slave_writedata -> NIOS:debug_mem_slave_writedata
	signal mm_interconnect_0_nios_ram_s1_chipselect                      : std_logic;                     -- mm_interconnect_0:NIOS_RAM_s1_chipselect -> NIOS_RAM:chipselect
	signal mm_interconnect_0_nios_ram_s1_readdata                        : std_logic_vector(31 downto 0); -- NIOS_RAM:readdata -> mm_interconnect_0:NIOS_RAM_s1_readdata
	signal mm_interconnect_0_nios_ram_s1_address                         : std_logic_vector(11 downto 0); -- mm_interconnect_0:NIOS_RAM_s1_address -> NIOS_RAM:address
	signal mm_interconnect_0_nios_ram_s1_byteenable                      : std_logic_vector(3 downto 0);  -- mm_interconnect_0:NIOS_RAM_s1_byteenable -> NIOS_RAM:byteenable
	signal mm_interconnect_0_nios_ram_s1_write                           : std_logic;                     -- mm_interconnect_0:NIOS_RAM_s1_write -> NIOS_RAM:write
	signal mm_interconnect_0_nios_ram_s1_writedata                       : std_logic_vector(31 downto 0); -- mm_interconnect_0:NIOS_RAM_s1_writedata -> NIOS_RAM:writedata
	signal mm_interconnect_0_nios_ram_s1_clken                           : std_logic;                     -- mm_interconnect_0:NIOS_RAM_s1_clken -> NIOS_RAM:clken
	signal mm_interconnect_0_timer_s1_chipselect                         : std_logic;                     -- mm_interconnect_0:Timer_s1_chipselect -> Timer:chipselect
	signal mm_interconnect_0_timer_s1_readdata                           : std_logic_vector(15 downto 0); -- Timer:readdata -> mm_interconnect_0:Timer_s1_readdata
	signal mm_interconnect_0_timer_s1_address                            : std_logic_vector(2 downto 0);  -- mm_interconnect_0:Timer_s1_address -> Timer:address
	signal mm_interconnect_0_timer_s1_write                              : std_logic;                     -- mm_interconnect_0:Timer_s1_write -> mm_interconnect_0_timer_s1_write:in
	signal mm_interconnect_0_timer_s1_writedata                          : std_logic_vector(15 downto 0); -- mm_interconnect_0:Timer_s1_writedata -> Timer:writedata
	signal mm_interconnect_0_nios_io_s1_chipselect                       : std_logic;                     -- mm_interconnect_0:NIOS_IO_s1_chipselect -> NIOS_IO:chipselect
	signal mm_interconnect_0_nios_io_s1_readdata                         : std_logic_vector(31 downto 0); -- NIOS_IO:readdata -> mm_interconnect_0:NIOS_IO_s1_readdata
	signal mm_interconnect_0_nios_io_s1_address                          : std_logic_vector(1 downto 0);  -- mm_interconnect_0:NIOS_IO_s1_address -> NIOS_IO:address
	signal mm_interconnect_0_nios_io_s1_write                            : std_logic;                     -- mm_interconnect_0:NIOS_IO_s1_write -> mm_interconnect_0_nios_io_s1_write:in
	signal mm_interconnect_0_nios_io_s1_writedata                        : std_logic_vector(31 downto 0); -- mm_interconnect_0:NIOS_IO_s1_writedata -> NIOS_IO:writedata
	signal mm_interconnect_0_adc_sample_store_csr_readdata               : std_logic_vector(31 downto 0); -- ADC:sample_store_csr_readdata -> mm_interconnect_0:ADC_sample_store_csr_readdata
	signal mm_interconnect_0_adc_sample_store_csr_address                : std_logic_vector(6 downto 0);  -- mm_interconnect_0:ADC_sample_store_csr_address -> ADC:sample_store_csr_address
	signal mm_interconnect_0_adc_sample_store_csr_read                   : std_logic;                     -- mm_interconnect_0:ADC_sample_store_csr_read -> ADC:sample_store_csr_read
	signal mm_interconnect_0_adc_sample_store_csr_write                  : std_logic;                     -- mm_interconnect_0:ADC_sample_store_csr_write -> ADC:sample_store_csr_write
	signal mm_interconnect_0_adc_sample_store_csr_writedata              : std_logic_vector(31 downto 0); -- mm_interconnect_0:ADC_sample_store_csr_writedata -> ADC:sample_store_csr_writedata
	signal mm_interconnect_0_adc_sequencer_csr_readdata                  : std_logic_vector(31 downto 0); -- ADC:sequencer_csr_readdata -> mm_interconnect_0:ADC_sequencer_csr_readdata
	signal mm_interconnect_0_adc_sequencer_csr_address                   : std_logic_vector(0 downto 0);  -- mm_interconnect_0:ADC_sequencer_csr_address -> ADC:sequencer_csr_address
	signal mm_interconnect_0_adc_sequencer_csr_read                      : std_logic;                     -- mm_interconnect_0:ADC_sequencer_csr_read -> ADC:sequencer_csr_read
	signal mm_interconnect_0_adc_sequencer_csr_write                     : std_logic;                     -- mm_interconnect_0:ADC_sequencer_csr_write -> ADC:sequencer_csr_write
	signal mm_interconnect_0_adc_sequencer_csr_writedata                 : std_logic_vector(31 downto 0); -- mm_interconnect_0:ADC_sequencer_csr_writedata -> ADC:sequencer_csr_writedata
	signal irq_mapper_receiver0_irq                                      : std_logic;                     -- JTAG_UART:av_irq -> irq_mapper:receiver0_irq
	signal irq_mapper_receiver1_irq                                      : std_logic;                     -- Timer:irq -> irq_mapper:receiver1_irq
	signal nios_irq_irq                                                  : std_logic_vector(31 downto 0); -- irq_mapper:sender_irq -> NIOS:irq
	signal rst_controller_reset_out_reset                                : std_logic;                     -- rst_controller:reset_out -> [NIOS_RAM:reset, irq_mapper:reset, mm_interconnect_0:NIOS_reset_reset_bridge_in_reset_reset, rst_controller_reset_out_reset:in, rst_translator:in_reset]
	signal rst_controller_reset_out_reset_req                            : std_logic;                     -- rst_controller:reset_req -> [NIOS:reset_req, NIOS_RAM:reset_req, rst_translator:reset_req_in]
	signal custom_reset_sync_0_reset_source_reset                        : std_logic;                     -- custom_reset_sync_0:Res_N_Out -> rst_controller:reset_in0
	signal rst_controller_001_reset_out_reset                            : std_logic;                     -- rst_controller_001:reset_out -> altpll_0:reset
	signal rst_controller_002_reset_out_reset                            : std_logic;                     -- rst_controller_002:reset_out -> custom_reset_sync_0:Res_N
	signal reset_reset_n_ports_inv                                       : std_logic;                     -- reset_reset_n:inv -> [rst_controller_001:reset_in0, rst_controller_002:reset_in0]
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_read_ports_inv  : std_logic;                     -- mm_interconnect_0_jtag_uart_avalon_jtag_slave_read:inv -> JTAG_UART:av_read_n
	signal mm_interconnect_0_jtag_uart_avalon_jtag_slave_write_ports_inv : std_logic;                     -- mm_interconnect_0_jtag_uart_avalon_jtag_slave_write:inv -> JTAG_UART:av_write_n
	signal mm_interconnect_0_timer_s1_write_ports_inv                    : std_logic;                     -- mm_interconnect_0_timer_s1_write:inv -> Timer:write_n
	signal mm_interconnect_0_nios_io_s1_write_ports_inv                  : std_logic;                     -- mm_interconnect_0_nios_io_s1_write:inv -> NIOS_IO:write_n
	signal rst_controller_reset_out_reset_ports_inv                      : std_logic;                     -- rst_controller_reset_out_reset:inv -> [ADC:reset_sink_reset_n, JTAG_UART:rst_n, NIOS:reset_n, NIOS_IO:reset_n, Timer:reset_n]

begin

	adc : component power1_ADC
		port map (
			clock_clk                  => altpll_0_c0_clk,                                   --            clock.clk
			reset_sink_reset_n         => rst_controller_reset_out_reset_ports_inv,          --       reset_sink.reset_n
			adc_pll_clock_clk          => altpll_0_c0_clk,                                   --    adc_pll_clock.clk
			adc_pll_locked_export      => custom_reset_sync_0_pll_locked_passthrough_export, --   adc_pll_locked.export
			sequencer_csr_address      => mm_interconnect_0_adc_sequencer_csr_address(0),    --    sequencer_csr.address
			sequencer_csr_read         => mm_interconnect_0_adc_sequencer_csr_read,          --                 .read
			sequencer_csr_write        => mm_interconnect_0_adc_sequencer_csr_write,         --                 .write
			sequencer_csr_writedata    => mm_interconnect_0_adc_sequencer_csr_writedata,     --                 .writedata
			sequencer_csr_readdata     => mm_interconnect_0_adc_sequencer_csr_readdata,      --                 .readdata
			sample_store_csr_address   => mm_interconnect_0_adc_sample_store_csr_address,    -- sample_store_csr.address
			sample_store_csr_read      => mm_interconnect_0_adc_sample_store_csr_read,       --                 .read
			sample_store_csr_write     => mm_interconnect_0_adc_sample_store_csr_write,      --                 .write
			sample_store_csr_writedata => mm_interconnect_0_adc_sample_store_csr_writedata,  --                 .writedata
			sample_store_csr_readdata  => mm_interconnect_0_adc_sample_store_csr_readdata,   --                 .readdata
			sample_store_irq_irq       => open                                               -- sample_store_irq.irq
		);

	jtag_uart : component power1_JTAG_UART
		port map (
			clk            => altpll_0_c0_clk,                                               --               clk.clk
			rst_n          => rst_controller_reset_out_reset_ports_inv,                      --             reset.reset_n
			av_chipselect  => mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect,      -- avalon_jtag_slave.chipselect
			av_address     => mm_interconnect_0_jtag_uart_avalon_jtag_slave_address(0),      --                  .address
			av_read_n      => mm_interconnect_0_jtag_uart_avalon_jtag_slave_read_ports_inv,  --                  .read_n
			av_readdata    => mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata,        --                  .readdata
			av_write_n     => mm_interconnect_0_jtag_uart_avalon_jtag_slave_write_ports_inv, --                  .write_n
			av_writedata   => mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata,       --                  .writedata
			av_waitrequest => mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest,     --                  .waitrequest
			av_irq         => irq_mapper_receiver0_irq                                       --               irq.irq
		);

	nios : component power1_NIOS
		port map (
			clk                                 => altpll_0_c0_clk,                                    --                       clk.clk
			reset_n                             => rst_controller_reset_out_reset_ports_inv,           --                     reset.reset_n
			reset_req                           => rst_controller_reset_out_reset_req,                 --                          .reset_req
			d_address                           => nios_data_master_address,                           --               data_master.address
			d_byteenable                        => nios_data_master_byteenable,                        --                          .byteenable
			d_read                              => nios_data_master_read,                              --                          .read
			d_readdata                          => nios_data_master_readdata,                          --                          .readdata
			d_waitrequest                       => nios_data_master_waitrequest,                       --                          .waitrequest
			d_write                             => nios_data_master_write,                             --                          .write
			d_writedata                         => nios_data_master_writedata,                         --                          .writedata
			debug_mem_slave_debugaccess_to_roms => nios_data_master_debugaccess,                       --                          .debugaccess
			i_address                           => nios_instruction_master_address,                    --        instruction_master.address
			i_read                              => nios_instruction_master_read,                       --                          .read
			i_readdata                          => nios_instruction_master_readdata,                   --                          .readdata
			i_waitrequest                       => nios_instruction_master_waitrequest,                --                          .waitrequest
			irq                                 => nios_irq_irq,                                       --                       irq.irq
			debug_reset_request                 => open,                                               --       debug_reset_request.reset
			debug_mem_slave_address             => mm_interconnect_0_nios_debug_mem_slave_address,     --           debug_mem_slave.address
			debug_mem_slave_byteenable          => mm_interconnect_0_nios_debug_mem_slave_byteenable,  --                          .byteenable
			debug_mem_slave_debugaccess         => mm_interconnect_0_nios_debug_mem_slave_debugaccess, --                          .debugaccess
			debug_mem_slave_read                => mm_interconnect_0_nios_debug_mem_slave_read,        --                          .read
			debug_mem_slave_readdata            => mm_interconnect_0_nios_debug_mem_slave_readdata,    --                          .readdata
			debug_mem_slave_waitrequest         => mm_interconnect_0_nios_debug_mem_slave_waitrequest, --                          .waitrequest
			debug_mem_slave_write               => mm_interconnect_0_nios_debug_mem_slave_write,       --                          .write
			debug_mem_slave_writedata           => mm_interconnect_0_nios_debug_mem_slave_writedata,   --                          .writedata
			dummy_ci_port                       => open                                                -- custom_instruction_master.readra
		);

	nios_io : component power1_NIOS_IO
		port map (
			clk        => altpll_0_c0_clk,                              --                 clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,     --               reset.reset_n
			address    => mm_interconnect_0_nios_io_s1_address,         --                  s1.address
			write_n    => mm_interconnect_0_nios_io_s1_write_ports_inv, --                    .write_n
			writedata  => mm_interconnect_0_nios_io_s1_writedata,       --                    .writedata
			chipselect => mm_interconnect_0_nios_io_s1_chipselect,      --                    .chipselect
			readdata   => mm_interconnect_0_nios_io_s1_readdata,        --                    .readdata
			in_port    => test_pio_output_in_port,                      -- external_connection.export
			out_port   => test_pio_output_out_port                      --                    .export
		);

	nios_ram : component power1_NIOS_RAM
		port map (
			clk        => altpll_0_c0_clk,                          --   clk1.clk
			address    => mm_interconnect_0_nios_ram_s1_address,    --     s1.address
			clken      => mm_interconnect_0_nios_ram_s1_clken,      --       .clken
			chipselect => mm_interconnect_0_nios_ram_s1_chipselect, --       .chipselect
			write      => mm_interconnect_0_nios_ram_s1_write,      --       .write
			readdata   => mm_interconnect_0_nios_ram_s1_readdata,   --       .readdata
			writedata  => mm_interconnect_0_nios_ram_s1_writedata,  --       .writedata
			byteenable => mm_interconnect_0_nios_ram_s1_byteenable, --       .byteenable
			reset      => rst_controller_reset_out_reset,           -- reset1.reset
			reset_req  => rst_controller_reset_out_reset_req        --       .reset_req
		);

	timer : component power1_Timer
		port map (
			clk        => altpll_0_c0_clk,                            --   clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,   -- reset.reset_n
			address    => mm_interconnect_0_timer_s1_address,         --    s1.address
			writedata  => mm_interconnect_0_timer_s1_writedata,       --      .writedata
			readdata   => mm_interconnect_0_timer_s1_readdata,        --      .readdata
			chipselect => mm_interconnect_0_timer_s1_chipselect,      --      .chipselect
			write_n    => mm_interconnect_0_timer_s1_write_ports_inv, --      .write_n
			irq        => irq_mapper_receiver1_irq                    --   irq.irq
		);

	altpll_0 : component power1_altpll_0
		port map (
			clk       => clk_clk,                            --       inclk_interface.clk
			reset     => rst_controller_001_reset_out_reset, -- inclk_interface_reset.reset
			read      => open,                               --             pll_slave.read
			write     => open,                               --                      .write
			address   => open,                               --                      .address
			readdata  => open,                               --                      .readdata
			writedata => open,                               --                      .writedata
			c0        => altpll_0_c0_clk,                    --                    c0.clk
			c1        => altpll_0_c1_clk,                    --                    c1.clk
			areset    => open,                               --        areset_conduit.export
			locked    => altpll_0_locked_conduit_export,     --        locked_conduit.export
			phasedone => open                                --     phasedone_conduit.export
		);

	custom_reset_sync_0 : component reset_sync
		port map (
			Clk                    => altpll_0_c0_clk,                                   --                  clock.clk
			Res_N                  => rst_controller_002_reset_out_reset,                --             reset_sink.reset
			PLL_Locked             => altpll_0_locked_conduit_export,                    --     pll_locked_conduit.export
			Res_N_Out              => custom_reset_sync_0_reset_source_reset,            --           reset_source.reset
			PLL_Locked_Passthrough => custom_reset_sync_0_pll_locked_passthrough_export  -- pll_locked_passthrough.export
		);

	mm_interconnect_0 : component power1_mm_interconnect_0
		port map (
			altpll_0_c0_clk                         => altpll_0_c0_clk,                                           --                      altpll_0_c0.clk
			NIOS_reset_reset_bridge_in_reset_reset  => rst_controller_reset_out_reset,                            -- NIOS_reset_reset_bridge_in_reset.reset
			NIOS_data_master_address                => nios_data_master_address,                                  --                 NIOS_data_master.address
			NIOS_data_master_waitrequest            => nios_data_master_waitrequest,                              --                                 .waitrequest
			NIOS_data_master_byteenable             => nios_data_master_byteenable,                               --                                 .byteenable
			NIOS_data_master_read                   => nios_data_master_read,                                     --                                 .read
			NIOS_data_master_readdata               => nios_data_master_readdata,                                 --                                 .readdata
			NIOS_data_master_write                  => nios_data_master_write,                                    --                                 .write
			NIOS_data_master_writedata              => nios_data_master_writedata,                                --                                 .writedata
			NIOS_data_master_debugaccess            => nios_data_master_debugaccess,                              --                                 .debugaccess
			NIOS_instruction_master_address         => nios_instruction_master_address,                           --          NIOS_instruction_master.address
			NIOS_instruction_master_waitrequest     => nios_instruction_master_waitrequest,                       --                                 .waitrequest
			NIOS_instruction_master_read            => nios_instruction_master_read,                              --                                 .read
			NIOS_instruction_master_readdata        => nios_instruction_master_readdata,                          --                                 .readdata
			ADC_sample_store_csr_address            => mm_interconnect_0_adc_sample_store_csr_address,            --             ADC_sample_store_csr.address
			ADC_sample_store_csr_write              => mm_interconnect_0_adc_sample_store_csr_write,              --                                 .write
			ADC_sample_store_csr_read               => mm_interconnect_0_adc_sample_store_csr_read,               --                                 .read
			ADC_sample_store_csr_readdata           => mm_interconnect_0_adc_sample_store_csr_readdata,           --                                 .readdata
			ADC_sample_store_csr_writedata          => mm_interconnect_0_adc_sample_store_csr_writedata,          --                                 .writedata
			ADC_sequencer_csr_address               => mm_interconnect_0_adc_sequencer_csr_address,               --                ADC_sequencer_csr.address
			ADC_sequencer_csr_write                 => mm_interconnect_0_adc_sequencer_csr_write,                 --                                 .write
			ADC_sequencer_csr_read                  => mm_interconnect_0_adc_sequencer_csr_read,                  --                                 .read
			ADC_sequencer_csr_readdata              => mm_interconnect_0_adc_sequencer_csr_readdata,              --                                 .readdata
			ADC_sequencer_csr_writedata             => mm_interconnect_0_adc_sequencer_csr_writedata,             --                                 .writedata
			JTAG_UART_avalon_jtag_slave_address     => mm_interconnect_0_jtag_uart_avalon_jtag_slave_address,     --      JTAG_UART_avalon_jtag_slave.address
			JTAG_UART_avalon_jtag_slave_write       => mm_interconnect_0_jtag_uart_avalon_jtag_slave_write,       --                                 .write
			JTAG_UART_avalon_jtag_slave_read        => mm_interconnect_0_jtag_uart_avalon_jtag_slave_read,        --                                 .read
			JTAG_UART_avalon_jtag_slave_readdata    => mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata,    --                                 .readdata
			JTAG_UART_avalon_jtag_slave_writedata   => mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata,   --                                 .writedata
			JTAG_UART_avalon_jtag_slave_waitrequest => mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest, --                                 .waitrequest
			JTAG_UART_avalon_jtag_slave_chipselect  => mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect,  --                                 .chipselect
			NIOS_debug_mem_slave_address            => mm_interconnect_0_nios_debug_mem_slave_address,            --             NIOS_debug_mem_slave.address
			NIOS_debug_mem_slave_write              => mm_interconnect_0_nios_debug_mem_slave_write,              --                                 .write
			NIOS_debug_mem_slave_read               => mm_interconnect_0_nios_debug_mem_slave_read,               --                                 .read
			NIOS_debug_mem_slave_readdata           => mm_interconnect_0_nios_debug_mem_slave_readdata,           --                                 .readdata
			NIOS_debug_mem_slave_writedata          => mm_interconnect_0_nios_debug_mem_slave_writedata,          --                                 .writedata
			NIOS_debug_mem_slave_byteenable         => mm_interconnect_0_nios_debug_mem_slave_byteenable,         --                                 .byteenable
			NIOS_debug_mem_slave_waitrequest        => mm_interconnect_0_nios_debug_mem_slave_waitrequest,        --                                 .waitrequest
			NIOS_debug_mem_slave_debugaccess        => mm_interconnect_0_nios_debug_mem_slave_debugaccess,        --                                 .debugaccess
			NIOS_IO_s1_address                      => mm_interconnect_0_nios_io_s1_address,                      --                       NIOS_IO_s1.address
			NIOS_IO_s1_write                        => mm_interconnect_0_nios_io_s1_write,                        --                                 .write
			NIOS_IO_s1_readdata                     => mm_interconnect_0_nios_io_s1_readdata,                     --                                 .readdata
			NIOS_IO_s1_writedata                    => mm_interconnect_0_nios_io_s1_writedata,                    --                                 .writedata
			NIOS_IO_s1_chipselect                   => mm_interconnect_0_nios_io_s1_chipselect,                   --                                 .chipselect
			NIOS_RAM_s1_address                     => mm_interconnect_0_nios_ram_s1_address,                     --                      NIOS_RAM_s1.address
			NIOS_RAM_s1_write                       => mm_interconnect_0_nios_ram_s1_write,                       --                                 .write
			NIOS_RAM_s1_readdata                    => mm_interconnect_0_nios_ram_s1_readdata,                    --                                 .readdata
			NIOS_RAM_s1_writedata                   => mm_interconnect_0_nios_ram_s1_writedata,                   --                                 .writedata
			NIOS_RAM_s1_byteenable                  => mm_interconnect_0_nios_ram_s1_byteenable,                  --                                 .byteenable
			NIOS_RAM_s1_chipselect                  => mm_interconnect_0_nios_ram_s1_chipselect,                  --                                 .chipselect
			NIOS_RAM_s1_clken                       => mm_interconnect_0_nios_ram_s1_clken,                       --                                 .clken
			Timer_s1_address                        => mm_interconnect_0_timer_s1_address,                        --                         Timer_s1.address
			Timer_s1_write                          => mm_interconnect_0_timer_s1_write,                          --                                 .write
			Timer_s1_readdata                       => mm_interconnect_0_timer_s1_readdata,                       --                                 .readdata
			Timer_s1_writedata                      => mm_interconnect_0_timer_s1_writedata,                      --                                 .writedata
			Timer_s1_chipselect                     => mm_interconnect_0_timer_s1_chipselect                      --                                 .chipselect
		);

	irq_mapper : component power1_irq_mapper
		port map (
			clk           => altpll_0_c0_clk,                --       clk.clk
			reset         => rst_controller_reset_out_reset, -- clk_reset.reset
			receiver0_irq => irq_mapper_receiver0_irq,       -- receiver0.irq
			receiver1_irq => irq_mapper_receiver1_irq,       -- receiver1.irq
			sender_irq    => nios_irq_irq                    --    sender.irq
		);

	rst_controller : component power1_rst_controller
		generic map (
			NUM_RESET_INPUTS          => 1,
			OUTPUT_RESET_SYNC_EDGES   => "deassert",
			SYNC_DEPTH                => 2,
			RESET_REQUEST_PRESENT     => 1,
			RESET_REQ_WAIT_TIME       => 1,
			MIN_RST_ASSERTION_TIME    => 3,
			RESET_REQ_EARLY_DSRT_TIME => 1,
			USE_RESET_REQUEST_IN0     => 0,
			USE_RESET_REQUEST_IN1     => 0,
			USE_RESET_REQUEST_IN2     => 0,
			USE_RESET_REQUEST_IN3     => 0,
			USE_RESET_REQUEST_IN4     => 0,
			USE_RESET_REQUEST_IN5     => 0,
			USE_RESET_REQUEST_IN6     => 0,
			USE_RESET_REQUEST_IN7     => 0,
			USE_RESET_REQUEST_IN8     => 0,
			USE_RESET_REQUEST_IN9     => 0,
			USE_RESET_REQUEST_IN10    => 0,
			USE_RESET_REQUEST_IN11    => 0,
			USE_RESET_REQUEST_IN12    => 0,
			USE_RESET_REQUEST_IN13    => 0,
			USE_RESET_REQUEST_IN14    => 0,
			USE_RESET_REQUEST_IN15    => 0,
			ADAPT_RESET_REQUEST       => 0
		)
		port map (
			reset_in0      => custom_reset_sync_0_reset_source_reset, -- reset_in0.reset
			clk            => altpll_0_c0_clk,                        --       clk.clk
			reset_out      => rst_controller_reset_out_reset,         -- reset_out.reset
			reset_req      => rst_controller_reset_out_reset_req,     --          .reset_req
			reset_req_in0  => '0',                                    -- (terminated)
			reset_in1      => '0',                                    -- (terminated)
			reset_req_in1  => '0',                                    -- (terminated)
			reset_in2      => '0',                                    -- (terminated)
			reset_req_in2  => '0',                                    -- (terminated)
			reset_in3      => '0',                                    -- (terminated)
			reset_req_in3  => '0',                                    -- (terminated)
			reset_in4      => '0',                                    -- (terminated)
			reset_req_in4  => '0',                                    -- (terminated)
			reset_in5      => '0',                                    -- (terminated)
			reset_req_in5  => '0',                                    -- (terminated)
			reset_in6      => '0',                                    -- (terminated)
			reset_req_in6  => '0',                                    -- (terminated)
			reset_in7      => '0',                                    -- (terminated)
			reset_req_in7  => '0',                                    -- (terminated)
			reset_in8      => '0',                                    -- (terminated)
			reset_req_in8  => '0',                                    -- (terminated)
			reset_in9      => '0',                                    -- (terminated)
			reset_req_in9  => '0',                                    -- (terminated)
			reset_in10     => '0',                                    -- (terminated)
			reset_req_in10 => '0',                                    -- (terminated)
			reset_in11     => '0',                                    -- (terminated)
			reset_req_in11 => '0',                                    -- (terminated)
			reset_in12     => '0',                                    -- (terminated)
			reset_req_in12 => '0',                                    -- (terminated)
			reset_in13     => '0',                                    -- (terminated)
			reset_req_in13 => '0',                                    -- (terminated)
			reset_in14     => '0',                                    -- (terminated)
			reset_req_in14 => '0',                                    -- (terminated)
			reset_in15     => '0',                                    -- (terminated)
			reset_req_in15 => '0'                                     -- (terminated)
		);

	rst_controller_001 : component power1_rst_controller_001
		generic map (
			NUM_RESET_INPUTS          => 1,
			OUTPUT_RESET_SYNC_EDGES   => "deassert",
			SYNC_DEPTH                => 2,
			RESET_REQUEST_PRESENT     => 0,
			RESET_REQ_WAIT_TIME       => 1,
			MIN_RST_ASSERTION_TIME    => 3,
			RESET_REQ_EARLY_DSRT_TIME => 1,
			USE_RESET_REQUEST_IN0     => 0,
			USE_RESET_REQUEST_IN1     => 0,
			USE_RESET_REQUEST_IN2     => 0,
			USE_RESET_REQUEST_IN3     => 0,
			USE_RESET_REQUEST_IN4     => 0,
			USE_RESET_REQUEST_IN5     => 0,
			USE_RESET_REQUEST_IN6     => 0,
			USE_RESET_REQUEST_IN7     => 0,
			USE_RESET_REQUEST_IN8     => 0,
			USE_RESET_REQUEST_IN9     => 0,
			USE_RESET_REQUEST_IN10    => 0,
			USE_RESET_REQUEST_IN11    => 0,
			USE_RESET_REQUEST_IN12    => 0,
			USE_RESET_REQUEST_IN13    => 0,
			USE_RESET_REQUEST_IN14    => 0,
			USE_RESET_REQUEST_IN15    => 0,
			ADAPT_RESET_REQUEST       => 0
		)
		port map (
			reset_in0      => reset_reset_n_ports_inv,            -- reset_in0.reset
			clk            => clk_clk,                            --       clk.clk
			reset_out      => rst_controller_001_reset_out_reset, -- reset_out.reset
			reset_req      => open,                               -- (terminated)
			reset_req_in0  => '0',                                -- (terminated)
			reset_in1      => '0',                                -- (terminated)
			reset_req_in1  => '0',                                -- (terminated)
			reset_in2      => '0',                                -- (terminated)
			reset_req_in2  => '0',                                -- (terminated)
			reset_in3      => '0',                                -- (terminated)
			reset_req_in3  => '0',                                -- (terminated)
			reset_in4      => '0',                                -- (terminated)
			reset_req_in4  => '0',                                -- (terminated)
			reset_in5      => '0',                                -- (terminated)
			reset_req_in5  => '0',                                -- (terminated)
			reset_in6      => '0',                                -- (terminated)
			reset_req_in6  => '0',                                -- (terminated)
			reset_in7      => '0',                                -- (terminated)
			reset_req_in7  => '0',                                -- (terminated)
			reset_in8      => '0',                                -- (terminated)
			reset_req_in8  => '0',                                -- (terminated)
			reset_in9      => '0',                                -- (terminated)
			reset_req_in9  => '0',                                -- (terminated)
			reset_in10     => '0',                                -- (terminated)
			reset_req_in10 => '0',                                -- (terminated)
			reset_in11     => '0',                                -- (terminated)
			reset_req_in11 => '0',                                -- (terminated)
			reset_in12     => '0',                                -- (terminated)
			reset_req_in12 => '0',                                -- (terminated)
			reset_in13     => '0',                                -- (terminated)
			reset_req_in13 => '0',                                -- (terminated)
			reset_in14     => '0',                                -- (terminated)
			reset_req_in14 => '0',                                -- (terminated)
			reset_in15     => '0',                                -- (terminated)
			reset_req_in15 => '0'                                 -- (terminated)
		);

	rst_controller_002 : component power1_rst_controller_001
		generic map (
			NUM_RESET_INPUTS          => 1,
			OUTPUT_RESET_SYNC_EDGES   => "deassert",
			SYNC_DEPTH                => 2,
			RESET_REQUEST_PRESENT     => 0,
			RESET_REQ_WAIT_TIME       => 1,
			MIN_RST_ASSERTION_TIME    => 3,
			RESET_REQ_EARLY_DSRT_TIME => 1,
			USE_RESET_REQUEST_IN0     => 0,
			USE_RESET_REQUEST_IN1     => 0,
			USE_RESET_REQUEST_IN2     => 0,
			USE_RESET_REQUEST_IN3     => 0,
			USE_RESET_REQUEST_IN4     => 0,
			USE_RESET_REQUEST_IN5     => 0,
			USE_RESET_REQUEST_IN6     => 0,
			USE_RESET_REQUEST_IN7     => 0,
			USE_RESET_REQUEST_IN8     => 0,
			USE_RESET_REQUEST_IN9     => 0,
			USE_RESET_REQUEST_IN10    => 0,
			USE_RESET_REQUEST_IN11    => 0,
			USE_RESET_REQUEST_IN12    => 0,
			USE_RESET_REQUEST_IN13    => 0,
			USE_RESET_REQUEST_IN14    => 0,
			USE_RESET_REQUEST_IN15    => 0,
			ADAPT_RESET_REQUEST       => 0
		)
		port map (
			reset_in0      => reset_reset_n_ports_inv,            -- reset_in0.reset
			clk            => altpll_0_c0_clk,                    --       clk.clk
			reset_out      => rst_controller_002_reset_out_reset, -- reset_out.reset
			reset_req      => open,                               -- (terminated)
			reset_req_in0  => '0',                                -- (terminated)
			reset_in1      => '0',                                -- (terminated)
			reset_req_in1  => '0',                                -- (terminated)
			reset_in2      => '0',                                -- (terminated)
			reset_req_in2  => '0',                                -- (terminated)
			reset_in3      => '0',                                -- (terminated)
			reset_req_in3  => '0',                                -- (terminated)
			reset_in4      => '0',                                -- (terminated)
			reset_req_in4  => '0',                                -- (terminated)
			reset_in5      => '0',                                -- (terminated)
			reset_req_in5  => '0',                                -- (terminated)
			reset_in6      => '0',                                -- (terminated)
			reset_req_in6  => '0',                                -- (terminated)
			reset_in7      => '0',                                -- (terminated)
			reset_req_in7  => '0',                                -- (terminated)
			reset_in8      => '0',                                -- (terminated)
			reset_req_in8  => '0',                                -- (terminated)
			reset_in9      => '0',                                -- (terminated)
			reset_req_in9  => '0',                                -- (terminated)
			reset_in10     => '0',                                -- (terminated)
			reset_req_in10 => '0',                                -- (terminated)
			reset_in11     => '0',                                -- (terminated)
			reset_req_in11 => '0',                                -- (terminated)
			reset_in12     => '0',                                -- (terminated)
			reset_req_in12 => '0',                                -- (terminated)
			reset_in13     => '0',                                -- (terminated)
			reset_req_in13 => '0',                                -- (terminated)
			reset_in14     => '0',                                -- (terminated)
			reset_req_in14 => '0',                                -- (terminated)
			reset_in15     => '0',                                -- (terminated)
			reset_req_in15 => '0'                                 -- (terminated)
		);

	reset_reset_n_ports_inv <= not reset_reset_n;

	mm_interconnect_0_jtag_uart_avalon_jtag_slave_read_ports_inv <= not mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;

	mm_interconnect_0_jtag_uart_avalon_jtag_slave_write_ports_inv <= not mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;

	mm_interconnect_0_timer_s1_write_ports_inv <= not mm_interconnect_0_timer_s1_write;

	mm_interconnect_0_nios_io_s1_write_ports_inv <= not mm_interconnect_0_nios_io_s1_write;

	rst_controller_reset_out_reset_ports_inv <= not rst_controller_reset_out_reset;

end architecture rtl; -- of power1
