-------------------------------------------------------------------------------
-- Simple LED Flasher
-------------------------------------------------------------------------------

library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

--============================================================================--
--================================== ENTITY ==================================--
--============================================================================--
entity led_flash is
	port (
		rsi_Res_N       : in  Std_Logic;                         
		csi_Clk  			: in  Std_Logic;             
		asi_Valid_In		: in 	std_Logic;
		asi_Data_In   : in Std_Logic_Vector(3 downto 0);
		aso_Valid_Out		: out 	std_Logic;
		aso_Data_Out   : out Std_Logic_Vector(3 downto 0)
	);
end led_flash;

--============================================================================--
--================================ ARCHITECTURE ==============================--
--============================================================================--
architecture RTL of led_flash is

  signal Simple_Counter  : Unsigned(26 downto 0);
  signal LED_internal	 : std_Logic_Vector(3 downto 0);
  signal Count_internal	 : std_Logic_Vector(26 downto 0);
  
begin

	-------------------------
	-- Simple counter process
	-------------------------
	Mr_counter: process (rsi_Res_N, csi_Clk)
	begin
		if rsi_Res_N = '0' then
			Simple_Counter <= (others => '0');
		elsif Rising_edge(csi_Clk) then
			Simple_Counter <= Simple_Counter + 1;
		end if;
	end process Mr_counter;    

	Count_internal <= not(std_Logic_Vector(Simple_Counter));
	
	aso_Data_Out <= asi_Data_In;
	aso_Valid_Out <= asi_Valid_In;
  
end RTL;










