
#--DashBoard--#
namespace eval reg_access_gui {
variable dash_path 
variable path
variable ptext

set dash_path [add_service dashboard myDash "" "Tools/REG ACCESS"]
set verbose 0x0

set master_list [get_service_paths master]
set path_no 0
foreach master $master_list {
	set path_list [ lindex [get_service_paths master] $path_no]
	incr path_no
}

	
dashboard_set_property $dash_path self developmentMode true
dashboard_set_property $dash_path self visible true
dashboard_set_property $dash_path self title ""

#--Layout Grid--#
#--Main Grid--#
dashboard_add $dash_path grdLayout group self
dashboard_set_property $dash_path grdLayout title ""
dashboard_set_property $dash_path grdLayout itemsPerRow 1
dashboard_set_property $dash_path grdLayout visible true
dashboard_set_property $dash_path grdLayout minWidth 450
dashboard_set_property $dash_path grdLayout minHeight 400

#--Logo Grid --#
dashboard_add $dash_path logo text grdLayout
dashboard_set_property $dash_path logo text "<font size=4 color=blue><B>SystemConsole Reg Access</B>"
dashboard_set_property $dash_path logo htmlCapable true
dashboard_set_property $dash_path logo editable false
dashboard_set_property $dash_path logo minWidth 450
dashboard_set_property $dash_path logo minHeight 20

#--REG Access Configuration Grid-#
dashboard_add $dash_path grdMemConfig group grdLayout
dashboard_set_property $dash_path grdMemConfig title "get_service_paths master"
dashboard_set_property $dash_path grdMemConfig itemsPerRow 1
dashboard_set_property $dash_path grdMemConfig minWidth 200
dashboard_set_property $dash_path grdMemConfig minHeight 50

dashboard_add $dash_path myTable table grdMemConfig
dashboard_set_property $dash_path myTable columnCount 2
dashboard_set_property $dash_path myTable rowCount [llength $master_list]
dashboard_set_property $dash_path myTable showGrid true
dashboard_set_property $dash_path myTable minWidth 200
dashboard_set_property $dash_path myTable columnHeader "No"
dashboard_set_property $dash_path myTable columnWidth 50
dashboard_set_property $dash_path myTable columnIndex 1
dashboard_set_property $dash_path myTable columnHeader "master"
dashboard_set_property $dash_path myTable columnWidth 800

set master_no 0
foreach master $master_list {
	dashboard_set_property $dash_path myTable columnIndex 0
	dashboard_set_property $dash_path myTable rowIndex $master_no
	dashboard_set_property $dash_path myTable cellText $master_no

	dashboard_set_property $dash_path myTable columnIndex 1
	dashboard_set_property $dash_path myTable rowIndex $master_no
	dashboard_set_property $dash_path myTable cellText [lindex $master_list $master_no]
	incr master_no
}

dashboard_add $dash_path grdservice group grdMemConfig
dashboard_set_property $dash_path grdservice title ""
dashboard_set_property $dash_path grdservice itemsPerRow 2
dashboard_set_property $dash_path grdservice minWidth 200
dashboard_set_property $dash_path grdservice minHeight 10

dashboard_set_property $dash_path myTable selectedRows 0
dashboard_add $dash_path openservice button grdservice
dashboard_set_property $dash_path openservice text " Open Service "
dashboard_set_property $dash_path openservice minWidth 100
dashboard_set_property $dash_path openservice minHeight 25
dashboard_set_property $dash_path openservice onClick {::reg_access_gui::openservice}

dashboard_add $dash_path closeservice button grdservice
dashboard_set_property $dash_path closeservice text " Close Service "
dashboard_set_property $dash_path closeservice minWidth 100
dashboard_set_property $dash_path closeservice minHeight 25
dashboard_set_property $dash_path closeservice onClick {::reg_access_gui::closeservice}
dashboard_set_property $dash_path closeservice enabled 0

#--Test Button Grid-#
dashboard_add $dash_path grdTest group grdLayout
dashboard_set_property $dash_path grdTest title "Reg Access"
dashboard_set_property $dash_path grdTest itemsPerRow 1
dashboard_set_property $dash_path grdTest minWidth 300
dashboard_set_property $dash_path grdTest minHeight 100

dashboard_add $dash_path wrtext group grdTest
dashboard_set_property $dash_path wrtext title ""
dashboard_set_property $dash_path wrtext itemsPerRow 6
dashboard_set_property $dash_path wrtext minWidth 200
dashboard_set_property $dash_path wrtext minHeight 10

dashboard_add $dash_path addrlabel label wrtext
dashboard_set_property $dash_path addrlabel text " Address: "
dashboard_set_property $dash_path addrlabel preferredWidth 50
dashboard_add $dash_path addrtext textField wrtext
dashboard_set_property $dash_path addrtext minWidth 80
dashboard_set_property $dash_path addrtext maxWidth 80
dashboard_set_property $dash_path addrtext text "0x00000000"

dashboard_add $dash_path datalabel label wrtext
dashboard_set_property $dash_path datalabel text "          Data: "
dashboard_set_property $dash_path datalabel preferredWidth 50
dashboard_add $dash_path datatext textField wrtext
dashboard_set_property $dash_path datatext minWidth 80
dashboard_set_property $dash_path datatext maxWidth 80
dashboard_set_property $dash_path datatext text "0x00000000"

dashboard_add $dash_path nolabel label wrtext
dashboard_set_property $dash_path nolabel text "         Number of Read: "
dashboard_set_property $dash_path nolabel preferredWidth 50
dashboard_add $dash_path notext textField wrtext
dashboard_set_property $dash_path notext minWidth 30
dashboard_set_property $dash_path notext maxWidth 30
dashboard_set_property $dash_path notext text "12"

dashboard_add $dash_path wrbutton group grdTest
dashboard_set_property $dash_path wrbutton title ""
dashboard_set_property $dash_path wrbutton itemsPerRow 2
dashboard_set_property $dash_path wrbutton minWidth 200
dashboard_set_property $dash_path wrbutton minHeight 10

#--Button - write--#
dashboard_add $dash_path btnRunCal button wrbutton
dashboard_set_property $dash_path btnRunCal text " Reg Write "
dashboard_set_property $dash_path btnRunCal minWidth 100
dashboard_set_property $dash_path btnRunCal minHeight 25
dashboard_set_property $dash_path btnRunCal onClick {::reg_access_gui::regwrite}

#--Button - read--#
dashboard_add $dash_path btnRunTG button wrbutton
dashboard_set_property $dash_path btnRunTG text " Reg Read "
dashboard_set_property $dash_path btnRunTG minWidth 100
dashboard_set_property $dash_path btnRunTG minHeight 25
dashboard_set_property $dash_path btnRunTG onClick {::reg_access_gui::regread}

#--Tcl Console Grid-#
dashboard_add $dash_path TclConsole group grdLayout
dashboard_set_property $dash_path TclConsole title "Message"
dashboard_set_property $dash_path TclConsole itemsPerRow 1
dashboard_set_property $dash_path TclConsole maxWidth 850
dashboard_set_property $dash_path TclConsole maxHeight 210
dashboard_set_property $dash_path TclConsole minWidth 850
dashboard_set_property $dash_path TclConsole minHeight 210

dashboard_add $dash_path tcltext text TclConsole
dashboard_set_property $dash_path tcltext expandableX 850
dashboard_set_property $dash_path tcltext expandableY 180
dashboard_set_property $dash_path tcltext maxWidth 850
dashboard_set_property $dash_path tcltext maxHeight 200
dashboard_set_property $dash_path tcltext editable 0
dashboard_set_property $dash_path tcltext text ""

dashboard_add $dash_path textClear button TclConsole
dashboard_set_property $dash_path textClear text " Clear "
dashboard_set_property $dash_path textClear minWidth 100
dashboard_set_property $dash_path textClear minHeight 25
dashboard_set_property $dash_path textClear onClick {::reg_access_gui::textclear}

proc openservice {} {
	variable dash_path
	variable path
	variable ptext
	
	dashboard_set_property $dash_path openservice enabled 0
    dashboard_set_property $dash_path closeservice enabled 1
	set master_no [dashboard_get_property $dash_path myTable selectedRows]
	set path [ lindex [get_service_paths master] $master_no]
    open_service master $path
	set ptext [dashboard_get_property $dash_path tcltext text]
	append ptext "open service --->" $path "\n" "\n"
	dashboard_set_property $dash_path tcltext text $ptext	
}

proc closeservice {} {
	variable dash_path
	variable path
	variable ptext

	dashboard_set_property $dash_path openservice enabled 1	
	dashboard_set_property $dash_path closeservice enabled 0	
    close_service master $path
	set ptext [dashboard_get_property $dash_path tcltext text]
	append ptext "close service --->" $path "\n" "\n"
	dashboard_set_property $dash_path tcltext text $ptext
}

proc textclear {} {
	variable dash_path
	 
	dashboard_set_property $dash_path tcltext text "" 
}

proc regwrite {} {
    variable dash_path	
	variable path
	variable ptext

	set addr [dashboard_get_property $dash_path addrtext text]
	set data [dashboard_get_property $dash_path datatext text]	
	master_write_32 $path $addr $data 	
	set ptext [dashboard_get_property $dash_path tcltext text]
	append ptext "Write $data at Address: $addr" "\n" "\n"
	dashboard_set_property $dash_path tcltext text $ptext		 
}

proc regread {} {
    variable dash_path
	variable path
	variable ptext
	
	set addr [dashboard_get_property $dash_path addrtext text]
	set data [dashboard_get_property $dash_path datatext text]	
	set no   [dashboard_get_property $dash_path notext text]	
	
	set ptext [dashboard_get_property $dash_path tcltext text]
	append ptext "Read data from Address: $addr" "\n" "[master_read_32 $path $addr $no]" "\n" "\n"
	dashboard_set_property $dash_path tcltext text $ptext		
}
}
